; simple tests of the procedures written for hw2

(load "hw2.scm")

(define pi 3.1415926535)
(define (identity x) x)
(define (inc x) (+ x 1))
(define (square x) (* x x))
(define (cube x) (* x x x))

(define (test-it s t)
  (display s)
  (display " => ")
  (display t)
  (eval s))

(test-it '(sum identity 1 inc 100) 5050)
(test-it '(sum cube 1 inc 10) 3025)

(test-it '(simp1 sin 0 pi 100) 2)
(test-it '(simp1 cube 0 1.0 100) .25)
(test-it '(simp1 cube -1 1 100) 0)

(test-it '(simp2 sin 0 pi 100) 2)
(test-it '(simp2 cube 0 1.0 100) .25)
(test-it '(simp2 cube -1 1 100) 0)

(test-it '(product identity 0 inc  10) 0)
(test-it '(product identity 1 inc  10) 3628800)
(test-it '(product square 10 inc 11) 12100)

(test-it '(factorial 10) 3628800)
(test-it '(factorial 1) 1)
(test-it '(factorial 3) 6)

(test-it '(accumulate + 0 identity 1 inc 10) 55)
(test-it '(accumulate * 1 identity 8 inc 10) 720)

(test-it '(acc-product identity 0 inc  10) 0)
(test-it '(acc-product identity 1 inc  10) 3628800)
(test-it '(acc-product square 10 inc 11) 12100)

(test-it '(wallis-pi 100) 3.149)
(test-it '(wallis-pi 200) 3.145)

(test-it '((double inc) 2) 4)
(test-it '((double inc) 3) 5)
(test-it '((double square) 2) 16)

(test-it '((compose square inc) 6) 49)
(test-it '((compose inc square) 6) 37)

(test-it '(car a) 1)
(test-it '(caadr a) 2)
(test-it '(cdadr a) 3)

(test-it '(caar b) 2)
(test-it '(cadar b) '())
(test-it '(caddar b) '())
(test-it '(cdddar b) '())

(define pairs9a (i-cons 1 2))
(test-it 'pairs9a 18)
(test-it '(i-car pairs9a) 1)
(test-it '(i-cdr pairs9a) 2)

(define pairs9b (i-cons (i-cons 1 2) 3))
(test-it 'pairs9b 7077888)
(test-it '(i-car (i-car pairs9b)) 1)
(test-it '(i-cdr (i-car pairs9b)) 2)
(test-it '(i-cdr pairs9b) 3)
